;void  restore_box(box,top_x,top_y,width,depth);
;  unsigned char  *box,top_x,top_y,width,depth;

	EXTRN  _memory_model:byte
	EXTRN  _video_buffer:word
	EXTRN  _snow_protect:byte

_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
	ASSUME  CS:_TEXT
	PUBLIC _restore_box
_restore_box proc near
	push bp			;
	mov  bp,sp		;set stack frame
	push di			;
	push si			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	mov  bl,_snow_protect	;grab _snow_protect
	push ds			;save DS
	cld			;set direction flag
	mov  ax,_video_buffer	;fetch video address
	mov  es,ax		;ES points to screen
	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	lds  si,dword ptr[bp+4] ;DS:SI pts to byte array
	add  bp,2		;forward BP since dword ptr
	jmp  short L00		;jump ahead
L0:	mov  si,[bp+4]		;NEAR case
L00:	mov  [bp+4],bl		;save _snow_protect on stack
	sub  ax,ax		;
	mov  al,[bp+8]		;row in AX
	dec  ax			;count rows from 0
	mov  dl,160		;160 bytes per row
	mul  dl			;AX times 160
	sub  dx,dx		;
	mov  dl,[bp+6]		;col in DX
	dec  dx			;count cols from 0
	shl  dx,1		;double for attributes
	add  ax,dx		;offset of topleft corner
	mov  bx,ax		;move scrn ptr to BX
	mov  dh,[bp+10]		;width in BX
	mov  dl,[bp+12]		;depth in DX
	sub  cx,cx		;clear CX
L1:	mov  di,bx		;set ES:DI scrn ptr
	mov  cl,dh		;width counter
	push dx			;save width,depth ctrs
L2:	cmp  byte ptr[bp+4],0	;protect against snow?
	je   L5			;jump ahead if not
	mov  dx,3dah		;status byte address
L3:	in   al,dx		;get status byte
	test al,1		;test bit
	jnz  L3			;loop till 0
	cli			;disable interrupts
L4:	in   al,dx		;get status byte
	test al,1		;test bit
	jz   L4			;loop till 1
L5:	movsw			;transfer char to scrn
	loop L2			;go do next in row
	pop  dx			;restore width,depth ctrs
	add  bx,160		;forward ptr to next row
	dec  dl			;dec depth counter
	jnz  L1			;loop if another line
L6:	sti			;reenable interrupts
	pop  ds			;
	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_restore_box endp
_TEXT	ENDS
	END
