;void  indent_line(strg,printer_codes,margin);
;  char  *strg,*printer_codes;
;  unsigned short  margin;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte
	EXTRN  _time_out:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME  CS:_TEXT
	PUBLIC  _indent_line
_indent_line proc near
	jmp  short start	;jmp over local data
delay	dw   ?			;
target  dw   ?			;
start:	push bp			;
	mov  bp,sp		;
	push di			;
	push si			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	push ds			;
	mov  ah,1		;BIOS func to init prtr
	sub  dx,dx		;choose LPT1
	int  17h		;initialize the prtr port
	sub  ax,ax		;clear AX
	mov  es,ax		;point ES to 0000:0000
	mov  dx,es:[408h]	;get LPT1 base address
	mov  _error_code,1	;1 = printer error
	mov  al,_time_out	;get _time_out seconds
	cmp  _memory_model,2	;data near or far?
	jb   A1			;jump if near
	les  di,dword ptr[bp+4] ;ES:DI pts to Strg
	lds  si,dword ptr[bp+8] ;DS:SI pts to PrinterCodes
	add  bp,4		;add 4 to BP since dword ptrs
	jmp  short B1		;
A1:	mov  si,[bp+6]		;NEAR case
	push ds			;
	pop  es			;
	mov  di,[bp+4]		;
B1:	or   al,al		;don't allow zero seconds
	jnz  C1			;
	mov  al,3		;default to 3 seconds
C1:	mov  cl,18		;18 ticks per second
	mul  cl			;
	mov  cs:delay,ax	;save count
	sub  cx,cx		;clear CX
	mov  cl,[bp+8]		;margin (255 chars max)
	jcxz E1			;jump if zero margin
D1:	mov  al,' '		;write space char
	call Writeit		;go write it
	or   ah,ah		;check for error
	jz   M1			;quit if printer error
	loop D1			;do next char in margin
E1:	cmp  byte ptr es:[di],0	;null string?
	je   L1			;go do CR-LF if null
F1:	mov  al,es:[di]		;get a character
	inc  di			;forward Strg ptr for next time
	cmp  al,0		;end of string?
	je   L1			;
	cmp  al,128		;test if control code
	jb   J1			;jump if below range
	cmp  al,159		;test if above
	ja   J1			;jump if above
	push cx			;save Strg len ctr
	push si			;copy PrinterCodes ptr
	sub  al,128		;count codes from 0
	mov  cl,6		;times six bytes
	mul  cl			;offset in PrinterCodes
	add  si,ax		;SI pts to code sequence
	sub  cx,cx		;clear CX
	mov  cl,[si]		;get string descriptor
	jcxz I1			;quit loop if null
G1:	inc  si			;forward ptr
	mov  al,[si]		;get code character
	call Writeit		;write the code
	or   ah,ah		;printer error?
	jnz  H1			;continue if not
	pop  cx			;balance stack
	pop  cx			;again
	jmp  short M1		;quit routine
H1:	loop G1			;go do next
I1:	pop  si			;prior Printercodes ptr
	pop  cx			;restore Strg len ctr
	jmp  short K1		;go get next char in Strg
J1:	call Writeit		;go write character
	or   ah,ah		;proc returned error?
	jz   M1			;quit if so
K1:	jmp  short F1		;loop
L1:	mov  al,13		;CR
	call Writeit		;print it
	or   ah,ah		;test for error
	jz   M1			;quit if error
	mov  al,10		;LF
	call Writeit		;print it
	or   ah,ah		;test for error
	jz   M1			;quit if error
	mov  al,1		;success return code
	pop  ds			;
	mov  _error_code,0	;0 = no error
	jmp  short N1		;
M1:	pop  ds			;
N1:	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
Writeit	PROC
	out  dx,al		;send to output data register
	inc  dx			;forward to status register
	push cx			;save string counter
	call GetBiosCount	;get timer reading
	mov  bx,cx		;make copy
	add  cx,cs:delay	;add delay count
	cmp  bx,cx		;if timer doesn't turn over...
	jb   O1			;go ahead
	mov  cx,cs:delay	;otherwise, extend delay
O1:	mov  cs:target,cx	;save target count
Wait:	in   al,dx		;get status value
	test al,8		;test for printer error
	jz   Error		;
	test al,80h		;test for Printer Ready
	jnz  Ready		;jump if ready
Error:	call GetBiosCount	;
	cmp  cx,cs:target	;compare to target
	jb   Wait		;	
	mov  bl,1		;1 = error
	pop  cx			;restore string counter
	mov  ah,0		;return code for failure
	jmp  short P1		;return
Ready:	pop  cx			;restore string counter
	inc  dx			; output control register
	mov  al,13		;bits for strobe signal
	out  dx,al		;send the signal
	dec  al			;change to strobe OFF
	out  dx,al		;send the signal
	dec  dx			;point back to
	dec  dx			;  base address
	mov  ah,1		;return code for success
P1:	ret  			;
Writeit	endp
GetBIOSCount PROC
	push dx			;return value in CX:DX
	push ax			;
	sub  ah,ah		;function number
	int  1ah		;get timer count
	mov  cx,dx		;low word in CX
	pop  ax			;
	pop  dx
	ret
GetBIOSCount endp
_indent_line endp
_TEXT	ENDS
	END
