;void  print_center(strg,field_size,fill_char);
;  char  *strg,fill_char;
;  unsigned short  field_size;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte
	EXTRN  _time_out:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME  CS:_TEXT
	PUBLIC  _print_center
_print_center proc near
	push bp
	mov  bp,sp
	push di	
	push si	
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	jmp  short A0
keep_count   dw ?
keep_target  dw ?
A0:	mov  ah,1		;BIOS func to init prtr
	sub  dx,dx		;choose LPT1
	int  17h		;initialize the prtr port
	sub  ax,ax		;clear AX
	mov  es,ax		;point ES to 0000:0000
	mov  dx,es:[408h]	;get LPT1 base address
	mov  _error_code,1	;1 = printer error
	cmp  _memory_model,2	;data near or far?
	jb   A1			;jump if near
	les  di,dword ptr[bp+4] ;ES:DI pts to Strg
	inc  bp			;add 2 to BP since dword ptr
	inc  bp			;
	jmp  short B1		;
A1:	mov  ax,ds		;ES = DS
	mov  es,ax		;	
	mov  di,[bp+4]		;near case
B1:	mov  al,_time_out	;get _time_out seconds
	or   al,al		;don't allow zero seconds
	jnz  C1			;
	sub  ax,ax		;
	mov  al,3		;default to 3 seconds
C1:	mov  cl,18		;18 ticks per second
	mul  cl			;
	mov  cs:keep_count,ax	;save count
	sub  cx,cx		;clear CX
	push di			;count string length...
C2:	cmp  byte ptr es:[di],0	;end of string?
	je   C3			;jump if so
	inc  di			;forward string ptr
	inc  cx			;inc length counter
	jmp  short C2		;loop
C3:	pop  di			;restore ptr to start of string
	sub  ax,ax		;clear AX
	mov  al,[bp+6]		;line length (255 max)
	or   al,al		;test for zero
	jz   L1			;quit if zero
	cmp  cx,ax		;compare Strg, field lens
	jbe  D1			;jump if Strg <=
	mov  cx,ax		;print only part of Strg
	sub  ax,ax		;use 0 in calculation
	jmp  short E1		;jump below
D1:	sub  ax,cx		;minus string length
E1:	mov  si,ax		;copy in SI
	shr  ax,1		;div by 2
	sub  si,ax		;remainder
	mov  [bp+6],cx		;save Strg len
	mov  cx,ax		;left border
	jcxz G1			;jump if no left border
F1:	mov  al,[bp+8]		;fetch fill character
	call Writeit		;write a character
	or   ah,ah		;check for printer error
	jz   L1			;quit if error
	loop F1			;go do next on left
G1:	mov  cx,[bp+6]		;fetch Strg length
	mov  ch,[bp+8]		;copy fill char in CH
	or   cl,cl		;test for null string
	jz   I1			;jump ahead if null
	cmp  _memory_model,2	;data near or far?
	jb   G2			;jump if near
	les  di,dword ptr[bp+2]	;point back to start of string
	jmp  short H1		;
G2:	mov  di,[bp+4]		;near case
H1:	mov  al,es:[di]		;get a character
	inc  di			;forward ptr for next time
	call Writeit		;write a char
	or   ah,ah		;proc returned error?
	jz   L1			;quit if so
	dec  cl			;dec Strg len ctr
	jnz  H1			;loop till finished
I1:	mov  al,ch		;fill char to AL
	mov  cx,si		;right border length
	jcxz K1			;quit if no right border
	mov  ch,al		;copy back to CH
J1:	mov  al,ch		;fill char to AL
	call Writeit		;print a character
	or   ah,ah		;check for printer error
	jz   L1			;quit if error
	dec  cl			;dec border len counter
	jnz  J1			;loop till finished
K1:	mov  al,1		;success return code
	dec  _error_code	;0 = no error
L1:	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
Writeit	PROC
	out  dx,al		;send to output data register
	inc  dx			;forward to status register
	push cx			;save string counter
	call GetBiosCount	;get timer reading
	mov  bx,cx		;make copy
	add  cx,cs:keep_count	;add delay count
	cmp  bx,cx		;if timer doesn't turn over...
	jb   O1			;go ahead
	mov  cx,cs:keep_count	;otherwise, extend delay
O1:	mov  cs:keep_target,cx	;save target count on stack
Wait:	in   al,dx		;get status value
	test al,8		;test for printer error
	jz   Error		;
	test al,80h		;test for Printer Ready
	jnz  Ready		;jump if ready
Error:	call GetBiosCount	;
	cmp  cx,cs:keep_target	;compare to target
	jb   Wait		;	
	mov  bl,1		;1 = error
	pop  cx			;restore string counter
	mov  ah,0		;return code for failure
	jmp  short P1		;return
Ready:	pop  cx			;restore string counter
	inc  dx			; output control register
	mov  al,13		;bits for strobe signal
	out  dx,al		;send the signal
	dec  al			;change to strobe OFF
	out  dx,al		;send the signal
	dec  dx			;point back to
	dec  dx			;  base address
	mov  ah,1		;return code for success
P1:	ret  			;
Writeit	endp
GetBIOSCount PROC
	push dx			;return value in CX:DX
	push ax			;
	sub  ah,ah		;function number
	int  1ah		;get timer count
	mov  cx,dx		;low word in CX
	pop  ax			;
	pop  dx
	ret
GetBIOSCount endp
_print_center endp
_TEXT	ENDS
	END
