;void  memory_map_word(character,color,offset);
;  unsigned char  character,color;
;  unsigned short  offset;

	EXTRN  _memory_model:byte
	EXTRN  _video_buffer:word
	EXTRN  _snow_protect:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _memory_map_word
_memory_map_word proc near
	push bp			;
	mov  bp,sp		;set stack frame
	push di			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	mov  ax,_video_buffer	;fetch video buffer address
	mov  es,ax		;move to ES
	mov  di,[bp+8]		;char offset in buffer
	mov  bh,[bp+6]		;attribute in BH
 	mov  bl,[bp+4]		;char in BL
	cmp  _snow_protect,0	;protect against snow?
	je   L3			;jump ahead if not
	mov  dx,3dah		;status byte address
L1:	in   al,dx		;get status byte
	test al,1		;test bit
	jnz  L1			;loop till 0
	cli			;disable interrupts
L2:	in   al,dx		;get status byte
	test al,1		;test bit
	jz   L2			;loop till 1
L3:	mov  ax,bx		;get character
	stosw			;write it
	sti			;reenable interrupts
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_memory_map_word endp
_TEXT	ENDS
	END
