;void  expand_tabs(strg,return_strg,max_length);
;  char  *strg,*return_strg;
;  unsigned short   max_length;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _expand_tabs
_expand_tabs proc near
	push bp			;
	mov  bp,sp		;
	push di			;
	push si			;
	push ds			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near	
	lds  si,dword ptr[bp+4] ;DS:SI pts to Strg
	les  di,dword ptr[bp+8] ;ES:DI pts to return strg
	mov  ax,[bp+12]		;max_length to al
	jmp  short L00		;jump ahead
L0:	mov  ax,ds		;near case
	mov  es,ax		;ES = DS
	mov  si,[bp+4]		;	
	mov  di,[bp+6]		;
	mov  ax,[bp+8]		;
L00:	mov  byte ptr es:[di],0	;return null string if error
	mov  bl,2		;error_code 2 = null string or strg>max_length
	or   ax,ax		;test for zero max_length
	jz   L8			;quit if zero
	push si			;must find string length
	sub  cx,cx		;cx counts
L1:	cmp  byte ptr[si],0	;end of string?
	je   L2			;quit loop when so
	inc  cx			;else inc counter
	inc  si			;forward ptr
	jmp  short L1		;loop
L2:	pop  si			;restore pointer to start of string
	jcxz L8			;quit if null string
	sub  ax,cx		;max_length minus strg len
	cmp  ax,0		;test 
	jl   L8			;quit if Strg won't fit
	dec  bl			;error_code 1 = no tab chars found
	mov  dh,al		;DH cts available spaces
	mov  dl,8		;initial tab column ptr
	dec  di			;pull back DI, since inc'ed in loop ahead
	dec  si			;same for SI
L3:	inc  si			;forward strg ptr
	inc  di			;forward return strg ptr
	dec  dl			;dec tab column ptr
	mov  al,[si]		;get a character
	cmp  al,9		;is it a tab?
	jne  L5			;jump ahead if not
	mov  bl,0		;error_code 0 = at least 1 tab char found
L4:	mov  byte ptr es:[di],32 ;write space
	or   dl,dl		;at tab column?
	jz   L6			;next char if not
	or   dh,dh		;extra space available?
	jz   L6			;leave loop if not
	dec  dh			;else dec space counter
	dec  dl			;dec tab column ptr
	inc  di			;forward ptr
	jmp  short L4		;go write another space
L5:	mov  es:[di],al		;move to return string
	inc  ch			;inc ret string len ctr
	or   dl,dl		;test tab column ptr
	jnz  L7			;jump ahead if not 0
L6:	mov  dl,8		;restore ctr to 8
L7:	dec  cl			;dec string length ctr
	jnz  L3			;loop till finished
	inc  di			;forward return string pointer
	mov  byte ptr es:[di],0	;set terminator
L8:	pop  ds			;restore DS
	mov  _error_code,bl	;set _error_code and quit
	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_expand_tabs ENDP
_TEXT	ENDS
	END
